<script setup lang="ts">
import { ref } from 'vue';

import { type Product } from '@/types/Products';
import { type ReceiptItem } from '@/types/ReceiptItem';

import ReceiptCard from './ReceiptCard.vue';
import ProductList from '@/components/ProductList.vue';
import { useReceiptStore } from '@/stores/receipt';
import ReceiptDetailTable from './ReceiptDetailTable.vue';
import { nextTick } from 'vue';
import MemberCard from './MemberCard.vue';
import { provide } from 'vue';
import ReceiptDialog from './ReceiptDialog.vue';

const receiptStore = useReceiptStore()

const products1: Product[] = [
    { id: 1, name: 'Americano', price: 35.00, type: 1 },
    { id: 2, name: 'Caffe Mocha', price: 55.00, type: 1 },
    { id: 3, name: 'Cappuccino Iced', price: 40.00, type: 1 },
    { id: 4, name: 'Caramel Frappuccino', price: 35.00, type: 1 },
    { id: 5, name: 'Iced Caffe Mocha', price: 35.00, type: 1 },
    { id: 6, name: 'Iced Matcha Espresso', price: 45.00, type: 1 },
    { id: 7, name: 'Matcha Espresso', price: 50.00, type: 1 },
    { id: 8, name: 'Vanilla Bean Latte Iced', price: 55.00, type: 1 },
    { id: 9, name: 'White Chocolate Mocha', price: 40.00, type: 1 },
]

const products2: Product[] = [
    { id: 10, name: 'Raspberry Cheesecake', price: 60.00, type: 2 },
    { id: 11, name: 'Mixed Berry Cheesecake', price: 60.00, type: 2 },
    { id: 12, name: 'Caramel Apple Cheesecake', price: 60.00, type: 2 },
    { id: 13, name: 'Tiramisu', price: 55.00, type: 2 },
    { id: 14, name: 'Orange Blossom Cupcakes', price: 50.00, type: 2 },
    { id: 15, name: 'Caramel Rockslide Brownie', price: 45.00, type: 2 },
    { id: 16, name: 'Sundae Ice Cream', price: 45.00, type: 2 },
    { id: 17, name: 'Bingsu', price: 70.00, type: 2 },
    { id: 18, name: 'Cinnabon Dessert Biscuits', price: 55.00, type: 2 },
]

const products3: Product[] = [
    { id: 19, name: 'Beef Hamburger', price: 79.00, type: 3 },
    { id: 20, name: 'French Fries', price: 55.00, type: 3 },
    { id: 21, name: 'Happy Meal', price: 159.00, type: 3 },
    { id: 22, name: 'Salmon Steak', price: 109.00, type: 3 },
    { id: 23, name: 'Mixed Pizza', price: 359.00, type: 3 },
    { id: 24, name: 'Beef Sausage Wrap', price: 99.00, type: 3 },
    { id: 25, name: 'Beef Steak', price: 89.00, type: 3 },
    { id: 26, name: 'Lamb BBQ', price: 109.00, type: 3 },
    { id: 27, name: 'Nugget', price: 59.00, type: 3 },
]

const tab = ref(1)
const selected = (p: Product) => {
    console.log('ProductView: ' + p)
    receiptStore.addReceiptItem(p)
    nextTick(() => {
        if (divReceiptItems.value) divReceiptItems.value.scrollTo(0, divReceiptItems.value.scrollHeight)
    })
}
const divReceiptItems = ref<HTMLElement | null>(null)

const dialog = ref(false)
provide('receiptDiaolog', dialog)

const showReceip = function () {
    receiptStore.showReceiptDialog()

}

</script>
<template>
    <v-container>
        <v-row>
            <v-col cols="12" md="6" style="background-color: rgb(97, 63, 45, 0.867)">
                <v-sheet min-width="300" max-width="600" height="650" elevation="6">
                    <v-tabs
                        v-model="tab"
                        color="deep-purple-accent-4"
                        align-tabs="center"
                    >
                        <v-tab :value="1">Drinks</v-tab>
                        <v-tab :value="2">Dessert</v-tab>
                        <v-tab :value="3">Food</v-tab>
                    </v-tabs>
                    <v-window v-model="tab">

                        <v-window-item :value="1">
                        <ProductList :products="products1" @selected-product="selected"></ProductList>
                        </v-window-item>

                        <v-window-item :value="2">
                        <ProductList :products="products2" @selected-product="selected"></ProductList>
                        </v-window-item>

                        <v-window-item :value="3">
                        <ProductList :products="products3" @selected-product="selected"></ProductList>
                        </v-window-item>

                    </v-window>
                </v-sheet>
            </v-col>
            <v-col cols="12" md="6" style="background-color: rgb(97, 63, 45, 0.867);">
                <v-container style="padding: 0">
                    <v-row >
                        <v-col cols="12">
                            <div ref="divReceiptItems" style="height: 285; overflow: auto;">
                            <v-sheet min-width="300" max-width="600" height="285" elevation="6"  >
                                 <ReceiptDetailTable></ReceiptDetailTable>                   
                            </v-sheet>
                        </div>
                        </v-col>

                        <v-col cols="12">
                            <v-sheet min-width="300" max-width="600" height="90" elevation="6" >
                                <MemberCard></MemberCard>
                            </v-sheet>
                         </v-col>

                        <v-col cols="12">
                            <v-sheet min-width="300" max-width="600" height="150" elevation="6" >
                                <ReceiptCard></ReceiptCard>
                            </v-sheet>
                        </v-col>

                        <v-col cols="12"> 
                            <v-sheet min-width="300" max-width="600" height="80" elevation="6">
                                <v-container>
                                    <v-row>                                
                                        <v-col cols="12" sm="6">
                                                <v-btn block rounded="lg" color="red" size="large" @click="receiptStore.clear" >Cancel</v-btn>
                                            </v-col>                            
                                            <v-col cols="12" sm="6">
                                                <v-btn block  rounded="lg" color="rgb(1, 86, 52)" size="large" 
                                                @click="showReceip">Confirm</v-btn>
                                            </v-col>
        
                                    </v-row>
                                </v-container>
                            </v-sheet>
                        </v-col>
                    </v-row>
                </v-container>
            </v-col>
        </v-row>
    </v-container>
    <ReceiptDialog></ReceiptDialog>
</template>